## mingw-w64-vtk-9.4.2-3.src.tar.zst

=== Examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12...3.16 FATAL_ERROR)
project(VTKExamples)

if (VTK_BINARY_DIR)
  function (add_example dir)
    if (vtk_cmake_build_dir)
      add_test(
        NAME    "VTKExample-${dir}"
        COMMAND "${CMAKE_COMMAND}"
                "-Dconfig=$<CONFIGURATION>"
                "-Dgenerator=${CMAKE_GENERATOR}"
                "-Dsource=${CMAKE_CURRENT_SOURCE_DIR}"
                "-Dbinary=${CMAKE_CURRENT_BINARY_DIR}"
                "-Dexample_dir=${dir}"
                "-Dbuild_type=${CMAKE_BUILD_TYPE}"
                "-Dshared=${BUILD_SHARED_LIBS}"
                "-Dvtk_dir=${vtk_cmake_build_dir}"
                "-Dctest=${CMAKE_CTEST_COMMAND}"
                "-Dplatform=${CMAKE_GENERATOR_PLATFORM}"
                "-Dtoolset=${CMAKE_GENERATOR_TOOLSET}"
                "-Dvtk_binary_dir=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
                -P "${CMAKE_CURRENT_LIST_DIR}/RunExample.cmake")
      set_property(TEST "VTKExample-${dir}" APPEND
        PROPERTY
          SKIP_REGULAR_EXPRESSION "Skipping example")
    endif ()
  endfunction ()
else ()
  macro (add_example dir)
    add_subdirectory("${dir}")
  endmacro ()
endif ()

if (ANDROID)
  #add_example(Android)
elseif (APPLE_IOS)
  #add_example(iOS)
elseif (EMSCRIPTEN)
  if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.13)
    add_example(Emscripten/Cxx/AsyncClipper)
    add_example(Emscripten/Cxx/Cone)
    add_example(Emscripten/Cxx/ConeFullScreen)
    add_example(Emscripten/Cxx/MultiCone)
    add_example(Emscripten/Cxx/WrappedAsyncClipper)
    add_example(Emscripten/Cxx/WrappedMace)
  endif()
else ()
  add_example(AMR/Cxx)
  add_example(Annotation/Cxx/LabeledMesh)
  add_example(Build/vtkMy)
  add_example(Charts/Cxx)
  add_example(DataManipulation/Cxx)
  #add_example(GUI/Cocoa) # xcode project
  add_example(GUI/Qt/FourPaneViewer)
  add_example(GUI/Qt/ImageViewer)
  add_example(GUI/Qt/SimpleView)
  add_example(GUI/Qt/TouchGestureViewer)
  add_example(GUI/Qt/MinimalQtVTKApp)
  add_example(GUI/QML/QtQuickProperty)
  add_example(GUI/QML/QtQuickBoxWidget)
  add_example(GUI/QML/QtQuickChartsOn3DScene)
  add_example(GUI/QML/QtQuickCone)
  add_example(IO/Cxx)
  add_example(ImageProcessing/Cxx)
  add_example(Infovis/Cxx)
  add_example(Medical/Cxx)
  add_example(Modelling/Cxx)
  add_example(MultiBlock/Cxx)
  add_example(ParallelProcessing/Generic/Cxx)

  add_example(Modules/UsingVTK)
  add_example(Modules/Wrapping)
endif ()

=== Interaction/Widgets/CMakeLists.txt ===
set(classes
  vtk3DCursorRepresentation
  vtk3DCursorWidget
  vtk3DWidget
  vtkAbstractPolygonalHandleRepresentation3D
  vtkAbstractSplineRepresentation
  vtkAbstractWidget
  vtkAffineRepresentation
  vtkAffineRepresentation2D
  vtkAffineWidget
  vtkAngleRepresentation
  vtkAngleRepresentation2D
  vtkAngleRepresentation3D
  vtkAngleWidget
  vtkAxesTransformRepresentation
  vtkAxesTransformWidget
  vtkBalloonRepresentation
  vtkBalloonWidget
  vtkBezierContourLineInterpolator
  vtkBiDimensionalRepresentation
  vtkBiDimensionalRepresentation2D
  vtkBiDimensionalWidget
  vtkBorderRepresentation
  vtkBorderWidget
  vtkBoundedPlanePointPlacer
  vtkBoxRepresentation
  vtkBoxWidget
  vtkBoxWidget2
  vtkBrokenLineWidget
  vtkButtonRepresentation
  vtkButtonWidget
  vtkCamera3DRepresentation
  vtkCamera3DWidget
  vtkCameraHandleSource
  vtkCameraOrientationWidget
  vtkCameraOrientationRepresentation
  vtkCameraPathRepresentation
  vtkCameraPathWidget
  vtkCameraRepresentation
  vtkCameraWidget
  vtkCaptionRepresentation
  vtkCaptionWidget
  vtkCellCentersPointPlacer
  vtkCenteredSliderRepresentation
  vtkCenteredSliderWidget
  vtkCheckerboardRepresentation
  vtkCheckerboardWidget
  vtkClosedSurfacePointPlacer
  vtkCompassRepresentation
  vtkCompassWidget
  vtkConstrainedPointHandleRepresentation
  vtkContinuousValueWidget
  vtkContinuousValueWidgetRepresentation
  vtkContourLineInterpolator
  vtkContourRepresentation
  vtkContourWidget
  vtkCoordinateFrameRepresentation
  vtkCoordinateFrameWidget
  vtkCurveRepresentation
  vtkDijkstraImageContourLineInterpolator
  vtkDisplaySizedImplicitPlaneWidget
  vtkDisplaySizedImplicitPlaneRepresentation
  vtkDistanceRepresentation
  vtkDistanceRepresentation2D
  vtkDistanceRepresentation3D
  vtkDistanceWidget
  vtkEllipsoidTensorProbeRepresentation
  vtkEqualizerContextItem
  vtkEvent
  vtkFinitePlaneRepresentation
  vtkFinitePlaneWidget
  vtkFixedSizeHandleRepresentation3D
  vtkFocalPlaneContourRepresentation
  vtkFocalPlanePointPlacer
  vtkHandleRepresentation
  vtkHandleWidget
  vtkHoverWidget
  vtkImageActorPointPlacer
  vtkImageCroppingRegionsWidget
  vtkImageOrthoPlanes
  vtkImagePlaneWidget
  vtkImageTracerWidget
  vtkImplicitAnnulusRepresentation
  vtkImplicitAnnulusWidget
  vtkImplicitConeRepresentation
  vtkImplicitConeWidget
  vtkImplicitCylinderRepresentation
  vtkImplicitCylinderWidget
  vtkImplicitImageRepresentation
  vtkImplicitPlaneRepresentation
  vtkImplicitPlaneWidget
  vtkImplicitPlaneWidget2
  vtkLightRepresentation
  vtkLightWidget
  vtkLinearContourLineInterpolator
  vtkLineRepresentation
  vtkLineWidget
  vtkLineWidget2
  vtkLogoRepresentation
  vtkLogoWidget
  vtkMagnifierRepresentation
  vtkMagnifierWidget
  vtkMeasurementCubeHandleRepresentation3D
  vtkOrientationMarkerWidget
  vtkOrientationRepresentation
  vtkOrientationWidget
  vtkOrientedGlyphContourRepresentation
  vtkOrientedGlyphFocalPlaneContourRepresentation
  vtkOrientedPolygonalHandleRepresentation3D
  vtkParallelopipedRepresentation
  vtkParallelopipedWidget
  vtkPlaneWidget
  vtkPlaybackRepresentation
  vtkPlaybackWidget
  vtkPointCloudRepresentation
  vtkPointCloudWidget
  vtkPointHandleRepresentation2D
  vtkPointHandleRepresentation3D
  vtkPointPlacer
  vtkPointWidget
  vtkPolyDataContourLineInterpolator
  vtkPolyDataPointPlacer
  vtkPolyDataSourceWidget
  vtkPolygonalHandleRepresentation3D
  vtkPolygonalSurfaceContourLineInterpolator
  vtkPolygonalSurfacePointPlacer
  vtkPolyLineRepresentation
  vtkPolyLineWidget
  vtkProgressBarRepresentation
  vtkProgressBarWidget
  vtkProp3DButtonRepresentation
  vtkRectilinearWipeRepresentation
  vtkRectilinearWipeWidget
  vtkResliceCursor
  vtkResliceCursorActor
  vtkResliceCursorLineRepresentation
  vtkResliceCursorPicker
  vtkResliceCursorPolyDataAlgorithm
  vtkResliceCursorRepresentation
  vtkResliceCursorThickLineRepresentation
  vtkResliceCursorWidget
  vtkScalarBarRepresentation
  vtkScalarBarWidget
  vtkSeedRepresentation
  vtkSeedWidget
  vtkSliderRepresentation
  vtkSliderRepresentation2D
  vtkSliderRepresentation3D
  vtkSliderWidget
  vtkSphereHandleRepresentation
  vtkSphereRepresentation
  vtkSphereWidget
  vtkSphereWidget2
  vtkSplineRepresentation
  vtkSplineWidget
  vtkSplineWidget2
  vtkTensorProbeRepresentation
  vtkTensorProbeWidget
  vtkTensorRepresentation
  vtkTensorWidget
  vtkTerrainContourLineInterpolator
  vtkTerrainDataPointPlacer
  vtkTextRepresentation
  vtkTexturedButtonRepresentation
  vtkTexturedButtonRepresentation2D
  vtkTextWidget
  vtkWidgetCallbackMapper
  vtkWidgetEvent
  vtkWidgetEventTranslator
  vtkWidgetRepresentation
  vtkWidgetSet
  vtkXYPlotWidget
  )

# Hand written (de)serialization routines
set(serialization_helper_sources)
if (VTK_WRAP_SERIALIZATION)
  list(APPEND serialization_helper_sources
    vtkAbstractWidgetSerDesHelper.cxx)
endif ()

vtk_module_add_module(VTK::InteractionWidgets
  CLASSES ${classes}
  SOURCES ${serialization_helper_sources})
vtk_add_test_mangling(VTK::InteractionWidgets)

=== IO/CGNS/Testing/CMakeLists.txt ===
vtk_module_test_data(
  Data/BCDirichletStructured.cgns
  Data/BCNeumannUnstructured.cgns
  Data/bc_struct.cgns
  Data/BoxWithFaceData.cgns
  Data/channelBump_solution.cgns
  Data/EngineSector.cgns
  Data/Example_fields.cgns
  Data/Example_grids.cgns
  Data/Example_mixed.cgns
  Data/Example_nface_n.cgns
  Data/Example_ngon_pe.cgns
  Data/Example_ngon_2d_base.cgns
  Data/MissingBase.cgns
  Data/MixedElementNodes.cgns
  Data/TemporalBox.cgns
  Data/TemporalBox_1.cgns
  Data/TemporalBox_2.cgns
  Data/test_cylinder.cgns
  Data/test_node_and_cell.cgns
  Data/UserDefinedData.cgns)

add_subdirectory(Cxx)

=== Filters/Core/Testing/Cxx/CMakeLists.txt ===
vtk_add_test_cxx(vtkFiltersCoreCxxTests tests
  Test3DLinearGridPlaneCutterCellData.cxx
  TestAppendArcLength.cxx,NO_VALID
  TestAppendDataSets.cxx,NO_VALID
  TestAppendFilter.cxx,NO_VALID
  TestAppendMolecule.cxx,NO_VALID
  TestAppendPartitionedDataSetCollection.cxx,NO_VALID
  TestAppendPolyData.cxx,NO_VALID
  TestAppendSelection.cxx,NO_VALID
  TestArrayCalculator.cxx,NO_VALID
  TestArrayRename.cxx,NO_VALID
  TestAssignAttribute.cxx,NO_VALID
  TestAttributeDataToTableFilter.cxx,NO_VALID
  TestAttributeDataToTableHyperTreeGrid.cxx,NO_VALID
  TestBinCellDataFilter.cxx,NO_VALID
  TestCategoricalPointDataToCellData.cxx,NO_VALID
  TestCategoricalResampleWithDataSet.cxx,NO_VALID
  TestCellCenters.cxx,NO_VALID
  TestCellDataToPointData.cxx,NO_VALID
  TestCenterOfMass.cxx,NO_VALID
  TestCleanPolyData.cxx,NO_VALID
  TestCleanPolyData2.cxx,NO_VALID
  TestClipPolyData.cxx,NO_VALID
  TestCompositeDataProbeFilterWithHyperTreeGrid.cxx
  TestConnectivityFilter.cxx,NO_VALID
  TestCutter.cxx,NO_VALID
  TestDataObjectToPartitionedDataSetCollection.cxx,NO_VALID
  TestDecimatePolylineFilter.cxx
  TestDecimatePro.cxx,NO_VALID
  TestDecimateProDegenerateTriangles.cxx,NO_VALID
  TestDelaunay2D.cxx
  TestDelaunay2DBestFittingPlane.cxx,NO_VALID
  TestDelaunay2DConstrained.cxx,NO_VALID
  TestDelaunay2DFindTriangle.cxx,NO_VALID
  TestDelaunay2DMeshes.cxx,NO_VALID
  TestDelaunay3D.cxx,NO_VALID
  TestExplicitStructuredGridCrop.cxx
  TestExplicitStructuredGridToUnstructuredGrid.cxx
  TestExecutionTimer.cxx,NO_VALID
  TestExtractCells.cxx,NO_VALID
  TestExtractCellsAlongPolyLine.cxx,NO_VALID
  TestFeatureEdges.cxx,NO_VALID
  TestFieldDataToDataSetAttribute.cxx,NO_VALID
  TestFlyingEdges.cxx
  TestGenerateIdsHTG.cxx,NO_VALID,NO_OUTPUT
  TestGlyph3D.cxx
  TestGlyph3DFollowCamera.cxx,NO_VALID
  TestHedgeHog.cxx,NO_VALID
  TestHyperTreeGridProbeFilter.cxx
  TestResampleHyperTreeGridWithDataSet.cxx
  TestImageDataToExplicitStructuredGrid.cxx
  TestImplicitPolyDataDistance.cxx
  TestImplicitPolyDataDistanceCube.cxx,NO_VALID
  TestImplicitProjectOnPlaneDistance.cxx
  TestMaskPoints.cxx,NO_VALID
  TestMaskPointsModes.cxx
  TestNamedComponents.cxx,NO_VALID
  TestPartitionedDataSetCollectionConvertors.cxx,NO_VALID
  TestPlaneCutter.cxx,NO_VALID
  TestPointDataToCellData.cxx,NO_VALID
  TestPolyDataConnectivityFilter.cxx,NO_VALID
  TestPolyDataNormals.cxx,NO_VALID
  TestPolyDataTangents.cxx
  TestProbeFilter.cxx,NO_VALID
  TestProbeFilterImageInput.cxx
  TestProbeFilterOutputAttributes.cxx,NO_VALID
  TestQuadricDecimationRegularization.cxx
  TestQuadricDecimationMapPointData.cxx
  TestResampleToImage.cxx,NO_VALID
  TestResampleToImage2D.cxx,NO_VALID
  TestResampleWithDataSet.cxx,
  TestResampleWithDataSet2.cxx
  TestResampleWithDataSet3.cxx
  TestRemoveDuplicatePolys.cxx,NO_VALID
  TestSmoothPolyDataFilter.cxx,NO_VALID
  TestSMPPipelineContour.cxx,NO_VALID
  TestSlicePlanePrecision.cxx,NO_VALID
  TestStaticCleanPolyData.cxx,NO_VALID
  TestStripper.cxx,NO_VALID
  TestStructuredGridAppend.cxx,NO_VALID
  TestSynchronizedTemplates2D.cxx,NO_VALID
  TestSynchronizedTemplates2DRGB.cxx,NO_DATA,NO_VALID
  TestThreshold.cxx,NO_VALID
  TestThresholdPoints.cxx,NO_VALID
  TestTransposeTable.cxx,NO_VALID
  TestTriangleMeshPointNormals.cxx
  TestTubeBender.cxx
  TestTubeFilter.cxx
  TestUnstructuredGridQuadricDecimation.cxx,NO_VALID
  TestUnstructuredGridToExplicitStructuredGrid.cxx
  TestUnstructuredGridToExplicitStructuredGridEmpty.cxx
  TestVaryRadiusTubeFilter.cxx
  UnitTestMaskPoints.cxx,NO_VALID
  UnitTestMergeFilter.cxx,NO_VALID
  TestContourImplicitArrays.cxx
  )

# This test fails on vtk-m due to bug #804 (vtk/vtkm)
# TODO: Remove from condition when fixed
if (NOT VTK_ENABLE_VTKM_OVERRIDES)
  vtk_add_test_cxx(vtkFiltersCoreCxxTests no_vtkm_tests
    TestThresholdComponents.cxx,NO_VALID)
endif()

set(all_tests
  ${tests}
  ${no_vtkm_tests}
  )

vtk_test_cxx_executable(vtkFiltersCoreCxxTests all_tests)

=== IO/Geometry/Testing/Cxx/CMakeLists.txt ===
vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestDataObjectIO.cxx,NO_VALID
  UnstructuredGridCellGradients.cxx
  UnstructuredGridFastGradients.cxx
  UnstructuredGridGradients.cxx
  TestFLUENTReader.cxx
  TestGLTFReaderMalformed.cxx,NO_VALID
  TestOBJReaderDouble.cxx
  TestOBJPolyDataWriter.cxx
  TestOBJReaderComments.cxx,NO_VALID
  TestOBJReaderGroups.cxx,NO_VALID
  TestOBJReaderMaterials.cxx,NO_VALID
  TestOBJReaderMultiline.cxx,NO_VALID
  TestOBJReaderMultiTexture.cxx,NO_VALID
  TestOBJWriterMultiTexture.cxx,NO_VALID
  TestOBJReaderNormalsTCoords.cxx,NO_VALID
  TestOBJReaderRelative.cxx,NO_VALID
  TestOBJReaderSingleTexture.cxx,NO_VALID
  TestOBJReaderMalformed.cxx,NO_VALID
  TestOFFReader.cxx,NO_VALID
  TestOpenFOAMReader.cxx
  TestOpenFOAMReaderDimensionedFields.cxx,NO_VALID
  TestOpenFOAMReaderFaceZone.cxx
  TestOpenFOAMReaderLagrangianSerial.cxx,NO_VALID
  TestOpenFOAMReaderLargePolyhedral.cxx,NO_VALID
  TestOpenFOAMReaderPrecision.cxx
  TestOpenFOAMReaderRegEx.cxx,NO_VALID
  TestOpenFOAMReaderValuePointPatch.cxx
  TestOpenFOAMReaderWeighByCellSize.cxx
  TestProStarReader.cxx
  TestTecplotReader.cxx
  TestAMRReadWrite.cxx,NO_VALID
  TestSimplePointsReaderWriter.cxx,NO_VALID
  TestHoudiniPolyDataWriter.cxx,NO_VALID
  UnitTestSTLWriter.cxx,NO_VALID
  )

# Certain test are expected failure with specific outputs
set_tests_properties(VTK::IOGeometryCxx-TestOBJReaderMalformed PROPERTIES PASS_REGULAR_EXPRESSION "Unexpected point index value")
set_tests_properties(VTK::IOGeometryCxx-TestOBJReaderMalformed PROPERTIES FAIL_REGULAR_EXPRESSION "")
set_tests_properties(VTK::IOGeometryCxx-TestGLTFReaderMalformed PROPERTIES PASS_REGULAR_EXPRESSION "Failed to read an image")
set_tests_properties(VTK::IOGeometryCxx-TestGLTFReaderMalformed PROPERTIES FAIL_REGULAR_EXPRESSION "")

LIST(APPEND tecplotFiles
    3dgeom.dat
    block_febrick_3d.dat
    block_fetet_3d.dat
    channel.dat
    crystal_plot.dat
    cube.dat
    cylinder_3d.dat
    cylinder_slice.dat
    cylindrical.dat
    ell.dat
    humanoid_quad.dat
    humanoid_tri.dat
    movie.dat
    multzn2d.dat
    plane_slice.dat
    point_febrick_3d_01.dat
    point_febrick_3d_02.dat
    point_fequad_2d.dat
    point_fetet_3d.dat
    point_fetri_2d_01.dat
    point_fetri_2d_03.dat
    simp3dbk.dat
    simp3dpt.dat
    simpscat.dat
    simpxy.dat
    simpxy2.dat
    tecplot_fepolygon.dat
    tecplot_fepolyhedron.dat
    tiny.dat
    1dgeom.dat
)
foreach(item IN LISTS tecplotFiles)
    get_filename_component(name "${item}" NAME_WE)

    vtk_add_test_cxx(vtkIOGeometryCxxTests tests
      TestTecplotReader2_${name},TestTecplotReader2.cxx ${item} NO_VALID NO_OUTPUT)

endforeach()

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestSTLReaderSinglePatch,TestSTLReader.cxx DATA{${_vtk_build_TEST_INPUT_DATA_DIRECTORY}/Data/42400-IDGH.stl}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestSTLReaderMultiplePatches,TestSTLReader.cxx DATA{${_vtk_build_TEST_INPUT_DATA_DIRECTORY}/Data/multiple_patches.stl}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestPTSReader,TestPTSReader.cxx DATA{${_vtk_build_TEST_INPUT_DATA_DIRECTORY}/Data/samplePTS.pts}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestAVSucdReaderContiguousASCII,TestAVSucdReader.cxx DATA{${_vtk_build_TEST_INPUT_DATA_DIRECTORY}/Data/cellsnd.ascii.inp}
)
vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestAVSucdReaderNonContiguousASCII,TestAVSucdReader.cxx DATA{${_vtk_build_TEST_INPUT_DATA_DIRECTORY}/Data/cellsnd.noncontiguous.ascii.inp}
)
vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestAVSucdReaderBinary,TestAVSucdReader.cxx DATA{${_vtk_build_TEST_INPUT_DATA_DIRECTORY}/Data/cellsnd.bin.inp}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderGeometry,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/Triangle/Triangle.gltf,simpleTriangle.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderGeometryNoBin,TestGLTFReaderGeometryNoBin.cxx DATA{../Data/glTF/Triangle/IncorrectDataNoBinFile.gltf} NO_VALID NO_OUTPUT
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderEmbeddedGeometry,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/Triangle/EmbeddedTriangle.gltf}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderGLBGeometry,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/Triangle/Triangle.glb}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderAnimation,TestGLTFReaderAnimation.cxx 200 DATA{../Data/glTF/BoxAnimated/BoxAnimated.gltf,BoxAnimated0.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderAnimationRange,TestGLTFReaderAnimationRange.cxx 1.807 DATA{../Data/glTF/BoxAnimated/BoxAnimated.gltf,BoxAnimated0.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderMorphing,TestGLTFReaderAnimation.cxx 200 DATA{../Data/glTF/AnimatedMorphCube/AnimatedMorphCube.gltf,AnimatedMorphCube.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderSkinning,TestGLTFReaderAnimation.cxx 200 DATA{../Data/glTF/SimpleSkin/SimpleSkin.gltf}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderMultipleAnimations,TestGLTFReaderAnimation.cxx 75 DATA{../Data/glTF/InterpolationTest/InterpolationTest.gltf,interpolation.bin,InterpolationTest_data.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderGeneratePointIndices,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/PrimitiveModes/Mesh_PrimitiveMode_POINTS.gltf,Mesh_PrimitiveMode_00.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderReadPointIndices,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/PrimitiveModes/Mesh_PrimitiveMode_POINTS_2.gltf,Mesh_PrimitiveMode_07.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderGenerateLineIndices,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/PrimitiveModes/Mesh_PrimitiveMode_LINES.gltf,Mesh_PrimitiveMode_01.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderReadLineIndices,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/PrimitiveModes/Mesh_PrimitiveMode_LINES_2.gltf,Mesh_PrimitiveMode_08.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderGenerateLineLoopIndices,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/PrimitiveModes/Mesh_PrimitiveMode_LINE_LOOP.gltf,Mesh_PrimitiveMode_02.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderReadLineLoopIndices,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/PrimitiveModes/Mesh_PrimitiveMode_LINE_LOOP_2.gltf,Mesh_PrimitiveMode_09.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderGenerateLineStripIndices,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/PrimitiveModes/Mesh_PrimitiveMode_LINE_STRIP.gltf,Mesh_PrimitiveMode_03.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderReadLineStripIndices,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/PrimitiveModes/Mesh_PrimitiveMode_LINE_STRIP_2.gltf,Mesh_PrimitiveMode_10.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderGenerateTriangleFanIndices,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/PrimitiveModes/Mesh_PrimitiveMode_TRIANGLE_FAN.gltf,Mesh_PrimitiveMode_05.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderReadTriangleFanIndices,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/PrimitiveModes/Mesh_PrimitiveMode_TRIANGLE_FAN_2.gltf,Mesh_PrimitiveMode_12.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderGenerateTriangleStripIndices,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/PrimitiveModes/Mesh_PrimitiveMode_TRIANGLE_STRIP.gltf,Mesh_PrimitiveMode_04.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderReadTriangleStripIndices,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/PrimitiveModes/Mesh_PrimitiveMode_TRIANGLE_STRIP_2.gltf,Mesh_PrimitiveMode_11.bin}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFReaderMissingProperty,TestGLTFReaderGeometry.cxx DATA{../Data/glTF/Triangle/material-no-pbrMetallicRoughness.gltf}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFWriterCityGML,TestGLTFWriter.cxx DATA{${_vtk_build_TEST_INPUT_DATA_DIRECTORY}/Data/CityGML/Part-4-Buildings-V4-one.gml}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFWriterObj,TestGLTFWriter.cxx DATA{${_vtk_build_TEST_INPUT_DATA_DIRECTORY}/Data/jacksonville_15.obj}
)

vtk_add_test_cxx(vtkIOGeometryCxxTests tests
  TestGLTFWriterCityGMLBinary,TestGLTFWriter.cxx DATA{${_vtk_build_TEST_INPUT_DATA_DIRECTORY}/Data/CityGML/Part-4-Buildings-V4-one.gml} binary
)


if(enable_large_data_tests)
  vtk_add_test_cxx(vtkIOGeometryCxxTests large_data_tests
    TestWindBladeReader.cxx
    TestMFIXReader.cxx,NO_VALID
    )
  list(APPEND tests
    ${large_data_tests}
    )
endif()

vtk_test_cxx_executable(vtkIOGeometryCxxTests tests)

=== Rendering/OpenGL2/Testing/Cxx/CMakeLists.txt ===
vtk_module_test_data(
  Data/pen_1.cur
  Data/pen_1.xcursor
  Data/overlap_faces.vtm
  Data/overlap_faces/overlap_faces_0_0.vtp
  Data/overlap_faces/overlap_faces_1_0.vtp
  Data/overlap_faces/overlap_faces_2_0.vtp
  )

if (CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  set(_vtk_test_cxx_wasm_enabled_in_browser ON)
  set(_vtk_test_emscripten_extra_linker_args
    # O2 or higher make wasm-opt terribly slow.
    # test executables take a minute to link.
    "-O1"
    # we need emscripten to emit code that handles exit code and atexit(s)
    "-sEXIT_RUNTIME=1"
    "-sALLOW_MEMORY_GROWTH=1")
endif ()
vtk_add_test_cxx(vtkRenderingOpenGL2CxxTests tests
  TestBlockVisibility.cxx
  TestBlurAndSobelPasses.cxx
  TestCameraShiftScale.cxx,NO_DATA
  TestCoincident.cxx
  TestCoincidentFloor.cxx
  TestCompositeDataOverlappingCells.cxx,
  TestCompositeDataPointGaussian.cxx,NO_DATA
  TestCompositeDataPointGaussianSelection.cxx,NO_DATA
  TestCompositePolyDataMapper2.cxx,NO_DATA
  TestCompositePolyDataMapper2CameraShiftScale.cxx,NO_DATA
  TestCompositePolyDataMapper2CellScalars.cxx,NO_DATA
  TestCompositePolyDataMapper2CustomShader.cxx,NO_DATA
  TestCompositePolyDataMapper2MixedGeometryCellScalars.cxx,NO_DATA
  TestCompositePolyDataMapper2MixedGeometryEdges.cxx,NO_DATA
  TestCompositePolyDataMapper2NaNPartial.cxx,NO_DATA
  TestCompositePolyDataMapper2PartialFieldData.cxx,NO_DATA
  TestCompositePolyDataMapper2PartialPointData.cxx,NO_DATA
  TestCompositePolyDataMapper2Pickability.cxx,NO_DATA
  TestCompositePolyDataMapper2Picking.cxx,NO_DATA
  TestCompositePolyDataMapper2Scalars.cxx,NO_DATA
# TestCompositePolyDataMapper2ScalarsSurfaceOpacity.cxx,NO_DATA #19221
  TestCompositePolyDataMapper2SharedArray.cxx,NO_DATA
  TestCompositePolyDataMapper2Spheres.cxx,NO_DATA
  TestCompositePolyDataMapper2Vertices.cxx,NO_DATA
  TestComputeShader.cxx,NO_DATA,NO_VALID,NO_OUTPUT
  TestCubeMap.cxx
  TestCubeMap2.cxx
  TestCubeMapRerender.cxx
  TestCustomCursorShape.cxx,NO_VALID
  TestDepthOfFieldPass.cxx
  TestDepthPeelingOcclusionQuery.cxx
  TestDepthPeelingPass.cxx
  TestDepthPeelingPassViewport.cxx
  TestEDLPass.cxx
  TestEquirectangularToCubeMap.cxx
  TestFXAAFilter.cxx
  TestFXAAPass.cxx
  TestFXAAWithEDLPass.cxx
  TestFlipRenderFramebuffer.cxx
  TestFloor.cxx,LOOSE_VALID
  TestFluidMapper.cxx
  TestFramebufferHDR.cxx
  TestFramebufferPass.cxx
  TestGaussianBlurPass.cxx
  TestGlyph3DMapperCellPicking.cxx
  TestGlyph3DMapperCulling.cxx
  TestGlyph3DMapperEdges.cxx
  TestGlyph3DMapperPickability.cxx,NO_DATA
  TestGlyph3DMapperTreeIndexingCompositeGlyphs.cxx,NO_DATA
  TestHiddenLineRemovalPass.cxx
  TestLightingMapLuminancePass.cxx
  TestLightingMapNormalsPass.cxx
  TestMultiTexturing.cxx
  TestMultiTexturingInterpolateScalars.cxx
  TestNormalMapping.cxx
  TestNormalMappingWithEdges.cxx
  TestOffscreenRenderingResize.cxx
  TestOutlineGlowPass.cxx
  TestOrderIndependentTranslucentPass.cxx
  TestPanoramicProjectionPass.cxx,NO_DATA
  TestPBRClearCoat.cxx
  TestPBREdgeTint.cxx
  TestPBRHdrEnvironment.cxx
  TestPBRAnisotropy.cxx
  TestPBRColorMultiplier.cxx
  TestPBRIrradianceHDR.cxx
  TestPBRMapping.cxx
  TestPBRMaterials.cxx
  TestPBRMaterialsCoat.cxx
  TestPBRTextureInterpolateScalars.cxx
  TestPointFillPass.cxx
  TestPointGaussianMapper.cxx
  TestPointGaussianMapperAnisotropic.cxx
  TestPointGaussianMapperOpacity.cxx
  TestPointGaussianSelection.cxx,NO_DATA
  TestProgramPointSize.cxx
  TestPropPicker2Renderers.cxx,NO_DATA
  TestRemoveActorNonCurrentContext.cxx
  TestRenderToImage.cxx
  TestSetZBuffer.cxx
  TestShadowMapBakerPass.cxx
  TestShadowMapPass.cxx
  TestSharedRenderWindow.cxx
  TestDirectSelectionRendering.cxx
  TestSimpleMotionBlur.cxx
  TestSobelGradientMagnitudePass.cxx
  TestSphereMap.cxx
  TestSpherePoints.cxx
  TestSphereVertex.cxx
  TestSRGB.cxx
  TestSSAAPass.cxx
  TestSSAOPass.cxx
  TestSSAOPassWithRenderer.cxx
  TestSurfaceInterpolationSwitch.cxx
  TestTessellationShader.cxx,NO_DATA
  TestTexture16Bits.cxx,NO_DATA
  TestTexture32Bits.cxx,NO_DATA
  TestTextureBufferEmulation.cxx,NO_DATA,NO_VALID,NO_OUTPUT
  TestTextureInterpolateScalars.cxx
  TestToneMappingPass.cxx,NO_DATA
  TestUserShader.cxx
  TestUserShader2.cxx
  TestUserShader2D.cxx,NO_DATA
  TestValuePassFloatingPoint.cxx
  TestValuePassFloatingPoint2.cxx
  TestVBOPLYMapper.cxx
  TestVBOPointsLines.cxx
  TestWindowBlits.cxx
  UnitTestOpenGLUniforms.cxx,NO_DATA,NO_VALID,NO_OUTPUT
  )

# Allow local customization of timeout for this test.
if(NOT VTK_TEST_TIMEOUT_TestFramebufferHDR)
  set(VTK_TEST_TIMEOUT_TestFramebufferHDR 300)
endif()
set_tests_properties(VTK::RenderingOpenGL2Cxx-TestFramebufferHDR
  PROPERTIES TIMEOUT ${VTK_TEST_TIMEOUT_TestFramebufferHDR})

if (CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  if (VTK_USE_SDL2)
    vtk_add_test_cxx(vtkRenderingOpenGL2CxxTests tests TestSDL2.cxx)
  endif ()
endif ()

if (VTK_USE_WIN32_OPENGL)
  vtk_add_test_cxx(vtkRenderingOpenGL2CxxTests tests
    TestWin32OpenGLDXRenderWindow.cxx)
endif ()

vtk_test_cxx_executable(vtkRenderingOpenGL2CxxTests tests
  DISABLE_FLOATING_POINT_EXCEPTIONS
  RENDERING_FACTORY
  )

if (VTK_USE_WIN32_OPENGL)
  # TestWin32OpenGLDXRenderWindow requires DirectX
  find_package(DirectX REQUIRED)
  target_link_libraries(vtkRenderingOpenGL2CxxTests PRIVATE DirectX::d3d11 DirectX::dxgi)
endif ()

=== ThirdParty/vtkm/vtkvtkm/vtk-m/vtkm/filter/zfp/worklet/CMakeLists.txt ===
##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================

set(headers
  ZFP1DCompressor.h
  ZFP1DDecompress.h
  ZFP2DCompressor.h
  ZFP2DDecompress.h
  ZFPCompressor.h
  ZFPDecompress.h
  )

add_subdirectory(zfp)

#-----------------------------------------------------------------------------
vtkm_declare_headers(${headers})

=== ThirdParty/vtkm/vtkvtkm/vtk-m/vtkm/interop/anari/testing/CMakeLists.txt ===
##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================

vtkm_unit_tests(
SOURCES
  UnitTestANARIMapperGlyphs.cxx
  UnitTestANARIMapperPoints.cxx
  UnitTestANARIMapperTriangles.cxx
  UnitTestANARIMapperVolume.cxx
  UnitTestANARIScene.cxx
  )

=== PKGBUILD ===
# Maintainer: Sergey Popov <popov.sa@gmail.com>
# Contributor: Mario Emmenlauer <memmenlauer@biodataanalysis.de>

_realname=vtk
pkgbase="mingw-w64-${_realname}"
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=9.4.2
pkgrel=3
pkgdesc="A software system for 3D computer graphics, image processing and visualization (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.vtk.org/"
msys2_repository_url="https://gitlab.kitware.com/vtk/vtk"
msys2_references=(
  'archlinux: vtk'
  "cpe: cpe:/a:vtk:vtk"
)
license=("spdx:BSD-3-Clause")
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-double-conversion"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-fmt"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-tbb"
         "${MINGW_PACKAGE_PREFIX}-jsoncpp"
         "${MINGW_PACKAGE_PREFIX}-libharu"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread"
         "${MINGW_PACKAGE_PREFIX}-lz4"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openxr-sdk"
         "${MINGW_PACKAGE_PREFIX}-pugixml"
         $([[ ${MSYSTEM} == MINGW64 ]] || echo "${MINGW_PACKAGE_PREFIX}-verdict")
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-adios2"
             "${MINGW_PACKAGE_PREFIX}-alembic"
             $([[ ${MSYSTEM} == MINGW64 ]] || echo "${MINGW_PACKAGE_PREFIX}-anari-sdk")
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-cgns"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-ffmpeg"
             "${MINGW_PACKAGE_PREFIX}-fontconfig"
             "${MINGW_PACKAGE_PREFIX}-gdal"
             "${MINGW_PACKAGE_PREFIX}-gl2ps"
             "${MINGW_PACKAGE_PREFIX}-hdf5"
             "${MINGW_PACKAGE_PREFIX}-liblas"
             "${MINGW_PACKAGE_PREFIX}-libmariadbclient"
             "${MINGW_PACKAGE_PREFIX}-libpng"
             "${MINGW_PACKAGE_PREFIX}-libogg"
             "${MINGW_PACKAGE_PREFIX}-libtheora"
             "${MINGW_PACKAGE_PREFIX}-libxml2"
             "${MINGW_PACKAGE_PREFIX}-netcdf"
             "${MINGW_PACKAGE_PREFIX}-openslide"
             "${MINGW_PACKAGE_PREFIX}-opencascade"
             "${MINGW_PACKAGE_PREFIX}-openturns"
             "${MINGW_PACKAGE_PREFIX}-openvdb"
             "${MINGW_PACKAGE_PREFIX}-openvr"
             "${MINGW_PACKAGE_PREFIX}-pdal"
             # "${MINGW_PACKAGE_PREFIX}-pegtl" https://gitlab.kitware.com/vtk/vtk/-/issues/18151
             "${MINGW_PACKAGE_PREFIX}-postgresql"
             "${MINGW_PACKAGE_PREFIX}-proj"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-sqlite3"
             # "${MINGW_PACKAGE_PREFIX}-tk"
             "${MINGW_PACKAGE_PREFIX}-unixodbc"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp"
             )
optdepends=("${MINGW_PACKAGE_PREFIX}-adios2: I/O ADIOS2"
            "${MINGW_PACKAGE_PREFIX}-alembic: I/O Alembic"
            "${MINGW_PACKAGE_PREFIX}-boost-libs: InfovisBoost and InfovisBoostGraphAlgorithms modules"
            "${MINGW_PACKAGE_PREFIX}-cgns: CGNS Reader"
            "${MINGW_PACKAGE_PREFIX}-ffmpeg: I/O FFMPEG"
            "${MINGW_PACKAGE_PREFIX}-fontconfig: Fontconfig Rendering"
            "${MINGW_PACKAGE_PREFIX}-gdal: I/O GDAL"
            "${MINGW_PACKAGE_PREFIX}-gl2ps: PS Rendering"
            "${MINGW_PACKAGE_PREFIX}-hdf5: I/O HDF5"
            "${MINGW_PACKAGE_PREFIX}-liblas: I/O LAS"
            "${MINGW_PACKAGE_PREFIX}-libmariadbclient: I/O MySQL/MariaDB"
            "${MINGW_PACKAGE_PREFIX}-libpng: I/O PNG Images"
            "${MINGW_PACKAGE_PREFIX}-libogg: I/O OGG and Theora"
            "${MINGW_PACKAGE_PREFIX}-libtheora: I/O OGG and Theora"
            "${MINGW_PACKAGE_PREFIX}-libxml2: I/O Infovis"
            "${MINGW_PACKAGE_PREFIX}-netcdf: I/O netCDF"
            "${MINGW_PACKAGE_PREFIX}-opencascade: I/O OCCT"
            "${MINGW_PACKAGE_PREFIX}-openslide: DomainsMicroscopy"
            "${MINGW_PACKAGE_PREFIX}-openturns: OpenTURNS Filter"
            "${MINGW_PACKAGE_PREFIX}-openvdb: I/O OpenVDB"
            "${MINGW_PACKAGE_PREFIX}-openvr: OpenVR Rendering"
            "${MINGW_PACKAGE_PREFIX}-pdal: I/O PDAL"
            "${MINGW_PACKAGE_PREFIX}-postgresql: I/O PostgreSQL"
            "${MINGW_PACKAGE_PREFIX}-proj: GEOVis"
            "${MINGW_PACKAGE_PREFIX}-python: Python bindings"
            "${MINGW_PACKAGE_PREFIX}-python-matplotlib: Matplotlib renderer"
            "${MINGW_PACKAGE_PREFIX}-qt6-base: Qt Rendering"
            "${MINGW_PACKAGE_PREFIX}-qt6-declarative: Qt Qml plugin"
            "${MINGW_PACKAGE_PREFIX}-sqlite3: I/O SQL"
            # "${MINGW_PACKAGE_PREFIX}-tk: TCL bindings, Python Tk widgets"
            "${MINGW_PACKAGE_PREFIX}-unixodbc")
if [[ ${MSYSTEM} != MINGW64 ]]; then
  optdepends+=("${MINGW_PACKAGE_PREFIX}-anari-sdk: ANARI Rendering")
fi
source=(https://www.vtk.org/files/release/${pkgver%.*}/VTK-${pkgver}.tar.gz
        "001-no-exact-version-for-fast_float.patch"
        "002-llvm-19-compatibility.patch"
        "003-fix-build-with-fmt-11.patch"
        "004-accept-future-versions-of-boost-and-occ.patch"
        "005-remove-unused-method-from-mir-tables.patch"
        "006-fix-compile-error-for-contour-tree-print.patch"
        "007-dll-export-some-functions.patch"
        "008-update-to-diy-3.6.0.patch"
        "009-diy-3-compatibility.patch"
        "011-anari-integer-types.patch"
        "012-fix-build-with-netcdf-4.9.3.patch")
sha256sums=('36c98e0da96bb12a30fe53708097aa9492e7b66d5c3b366e1c8dc251e2856a02'
            '411b0521fcd2864acae0af20ba6334f69f7c605c9e31996529f64aa749d61065'
            '410ddfbb2acb66746771a0e1f3ad81230904f712729af29cd26e8aaaa19dc48e'
            '2d1795111b410e0fbb8e7b08fab2e83e37e74ca0d7fd6685d435d4b27f355b87'
            'a44b3ba4bdc02be4767ff48b8a7fd4206a53756a881421fca99f538b08a7b48c'
            '66e3ac19197fb9f6f49dc98a746919ed025619ab8dae433d153c22ca595d92bc'
            'ace675cf8a9081532756b66d4f1ca1b03b12dad719b79e8cfa60ee6d60e2eeaf'
            '6cc0c44b2cb9693b8ae101fdde186561633fc6e6629c6e797231331895baa5df'
            '7602c7b4afa61f57f27022d4ea015c6e3c1d4ab8df5907ca828e08bb48c26b20'
            '19ffd04b06b4c3c0c3f0b1b375cbac956191d4b7d3fa1066dc62bbfe78d69908'
            'd76aa1788bbe2dd14390d4c7a4e65bcd652e4521324a7982ef7ead2306c82436'
            'eabe075c71ea6bbabfe3d0f1bf10f01ec299c88a8a825866f944eeb0b067aa2e')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  apply_patch_with_msg \
    001-no-exact-version-for-fast_float.patch \
    002-llvm-19-compatibility.patch \
    003-fix-build-with-fmt-11.patch \
    004-accept-future-versions-of-boost-and-occ.patch \
    005-remove-unused-method-from-mir-tables.patch \
    006-fix-compile-error-for-contour-tree-print.patch \
    008-update-to-diy-3.6.0.patch \
    009-diy-3-compatibility.patch \
    011-anari-integer-types.patch \
    012-fix-build-with-netcdf-4.9.3.patch

  # Succeeds with Clang but fails with GCC!
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    apply_patch_with_msg \
      007-dll-export-some-functions.patch
  fi
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MSYSTEM} == MINGW64 ]]; then
    _extra_config+=("-DVTK_MODULE_ENABLE_VTK_RenderingAnari=NO"
                    "-DVTK_MODULE_USE_EXTERNAL_VTK_verdict=OFF")
  fi

  CFLAGS+=" ${CPPFLAGS}"
  CXXFLAGS+=" ${CPPFLAGS} -D_USE_MATH_DEFINES -w"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -Wno-dev \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DCMAKE_INSTALL_LICENSEDIR=share/licenses/vtk \
    -DBUILD_SHARED_LIBS=ON \
    -DPython3_EXECUTABLE="${MINGW_PREFIX}/bin/python.exe" \
    -DVTK_BUILD_TESTING=OFF \
    -DVTK_VERSIONED_INSTALL=OFF \
    -DVTK_BUILD_ALL_MODULES=ON \
    -DVTK_GROUP_ENABLE_MPI=NO \
    -DVTK_GROUP_ENABLE_Web=NO \
    -DVTK_MODULE_ENABLE_VTK_FiltersParallelVerdict=WANT \
    -DVTK_MODULE_ENABLE_VTK_FiltersTemporal=WANT \
    -DVTK_MODULE_ENABLE_VTK_IOERF=WANT \
    -DVTK_MODULE_ENABLE_VTK_IOFDS=WANT \
    -DVTK_MODULE_ENABLE_VTK_RenderingOpenXRRemoting=NO \
    -DVTK_MODULE_ENABLE_VTK_RenderingZSpace=NO \
    -DVTK_USE_EXTERNAL=ON \
    -DVTK_MODULE_USE_EXTERNAL_VTK_exprtk=OFF \
    -DVTK_MODULE_USE_EXTERNAL_VTK_ioss=OFF \
    -DVTK_MODULE_USE_EXTERNAL_VTK_pegtl=OFF \
    -DVTK_MODULE_USE_EXTERNAL_VTK_token=OFF \
    -DVTK_WRAP_JAVA=OFF \
    -DVTK_WRAP_PYTHON=ON \
    -DVTK_SMP_IMPLEMENTATION_TYPE=TBB \
    -DVTK_SMP_ENABLE_SEQUENTIAL=ON \
    -DVTK_SMP_ENABLE_STDTHREAD=ON \
    -DVTK_SMP_ENABLE_OPENMP=ON \
    -DVTK_USE_VIDEO_FOR_WINDOWS=ON \
    -DVTK_ENABLE_OSPRAY=OFF \
    -DVTK_ENABLE_REMOTE_MODULES=OFF \
    -DVTK_IGNORE_CMAKE_CXX11_CHECKS=ON \
    "${_extra_config[@]}" \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/Copyright.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  # Remove third party CMake patching for older versions than ours
  rm -rv "${pkgdir}"${MINGW_PREFIX}/lib/cmake/vtk/patches/3.{1{3,6,9},2{0,2,3}}
  # … as well as duplicate copies
  rm -rv "${pkgdir}"${MINGW_PREFIX}/lib/cmake/vtk/vtkm/{Find*.cmake,cmake/{Find*.cmake,3.15}}

}
